TLS 1.2 is in Feature Freeze
RFC 9851
Rich Salz
Akamai Technologies
rsalz@akamai.com
Nimrod Aviram
nimrod.aviram@gmail.com
January 2026
SEC
tls
TLS
features
Use of TLS 1.3, which fixes some known deficiencies in TLS 1.2, is growing. This document specifies that outside of urgent security fixes (as determined by TLS Working Group consensus), new TLS Exporter Labels, and new Application-Layer Protocol Negotiation (ALPN) Protocol IDs, no changes will be approved for TLS 1.2. This prescription pertains to TLS only; it does not pertain to DTLS (in any DTLS version).
Introduction
TLS 1.3 [RFC9846] fixes most known deficiencies with TLS 1.2 [RFC5246] and its use is growing. Some examples of the fixes include encrypting more of the traffic so that it is not readable by outsiders and removing most cryptographic primitives that are now considered weak. Importantly, TLS 1.3 enjoys robust security proofs.
Both versions have several extension points. Items like new cryptographic algorithms, new supported groups (formerly "named curves"), etc., can be added without defining a new protocol. This document specifies that outside of urgent security fixes (as determined by TLS Working Group consensus) and the exceptions listed in Section 4, no changes will be approved for TLS 1.2.
This prescription pertains to TLS only. As such, it does not pertain to DTLS, in any DTLS version.
Implications for Post-Quantum Cryptography (PQC)
Cryptographically relevant quantum computers, once available, are likely to greatly lessen the time and effort needed to break RSA, finite-field-based Diffie-Hellman (FFDH), or Elliptic Curve Cryptography (ECC) which are currently used in TLS. In 2016, the US National Institute of Standards and Technology (NIST) started a multi-year effort to standardize algorithms that will be "safe" once quantum computers are feasible [PQC]. Initial discussions in the IETF community happened around the same time [CFRGSLIDES].
In 2024, NIST released standards for [ML-KEM], [ML-DSA], and [SLH-DSA]. Many other countries and organizations are publishing their roadmaps, including the multi-national standards organization ETSI [ETSI].
While the industry was waiting for NIST to finish standardization, the IETF has had several efforts underway. A working group was formed in early 2023 to work on the use of Post-Quantum Cryptography (PQC) in IETF protocols [PQUIPWG]. Several other working groups, including TLS [TLSWG], are working on specifications to support hybrid algorithms and identifiers, for use during a transition from classic to a post-quantum world.
It is important to note that effort within the TLS Working Group is focused exclusively on TLS 1.3 or later. Put bluntly, PQC for TLS 1.2 will not be specified (see Section 4) at any time; anyone wishing to deploy PQC should expect to use TLS 1.3.
Security Considerations
This entire document is about security and provides post-quantum security concerns as an additional reason to upgrade to TLS 1.3.
IANA Considerations
No TLS registries [RFC9847] are being closed by this document. Rather, this document modifies the instructions to IANA and the TLS Designated Experts to constrain the type of entries that can be added to existing registries.
This document does not introduce any new limitations on the registrations for either of the following two registries:
- TLS Application-Layer Protocol Negotiation (ALPN) Protocol IDs
- TLS Exporter Labels
The following note has been added to the other TLS registries:
Any TLS entry added after the IESG approves publication of RFC 9851 is intended for TLS 1.3 or later, and makes no similar requirement on DTLS. Such entries should have an informal indication like "For TLS 1.3 or later" in that entry, such as the "Comment" column.
At the time of publication, the note has been added to the following TLS registries:
- TLS Alerts
- TLS Authorization Data Formats
- TLS CachedInformationType Values
- TLS Certificate Compression Algorithm IDs
- TLS Certificate Status Types
- TLS Certificate Types
- TLS Cipher Suites
- TLS ClientCertificateType Identifiers
- TLS ContentType
- TLS EC Curve Types
- TLS EC Point Formats
- TLS ExtensionType Values
- TLS HandshakeType
- TLS HashAlgorithm
- TLS Heartbeat Message Types
- TLS Heartbeat Modes
- TLS KDF Identifiers
- TLS PskKeyExchangeMode
- TLS SignatureAlgorithm
- TLS SignatureScheme
- TLS Supplemental Data Formats (SupplementalDataType)
- TLS Supported Groups
- TLS UserMappingType Values
Any TLS registry created after this document is approved for publication should indicate whether the actions defined here are applicable.
References
Normative References
[RFC9846]

The Transport Layer Security (TLS) Protocol Version 1.3
Eric Rescorla
Independent
January 2026
RFC 9846
DOI 10.17487/RFC9846
Informative References
[ML-KEM]

Module-Lattice-Based Key-Encapsulation Mechanism Standard
National Institute of Standards and Technology
August 2024
NIST FIPS 203
DOI 10.6028/NIST.FIPS.203
[ML-DSA]

Module-Lattice-Based Digital Signature Standard
National Institute of Standards and Technology
August 2024
NIST FIPS 204
DOI 10.6028/NIST.FIPS.204
[SLH-DSA]

Stateless Hash-Based Digital Signature Standard
National Institute of Standards and Technology
August 2024
NIST FIPS 205
DOI 10.6028/NIST.FIPS.205
[PQC]

Post-Quantum Cryptography (PQC)
NIST
January 2017
[CFRGSLIDES]

Post Quantum Secure Cryptography Discussion
David McGrew
April 2016
IETF 95 Proceedings
[PQUIPWG]

Post-Quantum Use in Protocols
IETF
[TLSWG]

Transport Layer Security
IETF
[ETSI]

CYBER; Migration strategies and recommendations to Quantum Safe schemes
European Telecommunications Standards Institute
July 2020
ETSI TR 103 619
Version 1.1.1
[RFC5246]
[RFC9847]
Acknowledgments
We gratefully acknowledge Amanda Baber, David Dong, and Sabrina Tanamal of IANA for their help in revising and clarifying Section 4.